package com.tptj.demo.hg.cell.property.provider;

import com.fr.design.cell.CellElementPropertyComponent;
import com.fr.design.fun.impl.AbstractCellPropertyPaneProvider;
import com.fr.design.mainframe.EastRegionContainerPane;
import com.fr.design.mainframe.JWorkBook;
import com.fr.design.mainframe.PaneHolder;
import com.fr.design.mainframe.PropertyItemBean;

import javax.swing.*;

import java.awt.event.ActionListener;
import java.util.ArrayList;

import static com.fr.design.mainframe.EastRegionContainerPane.PropertyMode.FORM_REPORT;
import static com.fr.design.mainframe.EastRegionContainerPane.PropertyMode.POLY_REPORT;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-06-03
 **/
public class DemoPane extends AbstractCellPropertyPaneProvider {
    private DemoComponent component = new DemoComponent();
    @Override
    public CellElementPropertyComponent getSingletonCelPropertyPane() {
        return component;
    }

    @Override
    protected PaneHolder getPathHolder0() {
        return new PaneHolder() {
            @Override
            public JPanel getInstance(Object arg) {
                return getSingletonCelPropertyPane().toPanel();
            }
        };
    }

    @Override
    protected Class sign() {
        return JWorkBook.class;
    }

    @Override
    public String key() {
        return "key";
    }

    @Override
    public PropertyItemBean getItem() {
        PropertyItemBean bean = new PropertyItemBean();
        bean.setName("key");
        bean.setTitle("KEY");
        bean.setBtnIconName("cellelement");
        bean.setVisibleModes(new EastRegionContainerPane.PropertyMode[]{
                EastRegionContainerPane.PropertyMode.REPORT,
                FORM_REPORT,
                POLY_REPORT});
        bean.setButtonListeners(new ArrayList<ActionListener>(0));
        bean.setEnableModes(new EastRegionContainerPane.PropertyMode[]{
                EastRegionContainerPane.PropertyMode.REPORT,
                FORM_REPORT,
                POLY_REPORT});
        return bean;
    }

    @Override
    public String replaceKey() {
        return null;
    }
}
